config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root 'home#index'

  resources :users, only: [:show] do
  	get 'shared_projects', on: :member
	  resources :projects, only: [:index, :new, :create]
    resources :trashes, only: [:index]
    resources :notifications, only: [:index, :destroy]
  end

  resources :projects, only: [:show, :edit, :update, :destroy] do
  	resources :tasks, only: [:new, :create, :index]
  	resources :contributors, only: [:new, :create, :index, :destroy]

    resources :links, only: [:new, :create] do
      get 'unlink', on: :member
    end

    resources :trashes, only: [:create] do
      collection { post 'restore', to: 'trashes#restore' }
    end
  end

  resources :tasks, only: [:edit, :update, :show] do
    resources :assignees, only: [:new, :create]
    post 'start', to: 'task_states#start'
    post 'ready', to: 'task_states#ready'
    post 'finish', to: 'task_states#finish'
    post 'accept', to: 'task_states#accept'
    post 'schedule', to: 'task_states#schedule'
    post 'stop', to: 'task_states#stop'
    post 'continue', to: 'task_states#continue'
    post 'verify', to: 'task_states#verify'
    post 'reject', to: 'task_states#reject'
    post 'discard', to: 'task_states#discard'
  end

  resources :links, only: [:destroy]
end

app/views/shared/_alerts.html.erb
<% if flash[:alert] %>
	<!-- Operation errors -->	
	<section class='alerts'><%= flash[:alert] %></section>
<% end %>

app/views/shared/_login_logout.html.erb
  <% if user_signed_in? %>
    <%= button_to t('devise.authentication.sign_out'), destroy_user_session_path, 
      method: :delete, id: 'user_sign_out', form_class: 'navbar-form navbar-right', class: 'btn btn-default' %>
  <% else %>
    <ul class="navbar-nav">
      <li><%= link_to t('devise.authentication.sign_up'), new_user_registration_path, 
        id: 'user_sign_up' %></li>
      <li><%= link_to t('devise.authentication.sign_in'), new_user_session_path, 
        id: 'user_sign_in' %></li>
    </ul>
  <% end %>

app/views/shared/_notices.html.erb
<% if flash[:notice] %>
  <div class="row">
    <div class="col-md-12">
      <section class='alert alert-info'><%= flash[:notice] %></section>
    </div>
  </div>
<% end %>

app/views/shared/_notifications_link.html.erb
<ul class="nav navbar-nav navbar-right">
  <li>
    <%= link_to user_notifications_path(current_user), id: 'notifications' do %>
      <p><span class="glyphicon glyphicon-bell"></span>
      <% unless notifications_count.zero? %>
        <span class="label label-danger" id="notifications_count"><%= notifications_count %></span>
      <% end %>
      </p>
    <% end %>
  </li>
</ul>

app/views/shared/_project_controllers.html.erb
<ul class="nav navbar-nav">
  <li><%= link_to t('nav.home'), 
    user_path(current_user) %></li>

  <% if @project.owner == current_user %>
    <li><%= link_to t('project.edit'), 
      edit_project_path(@project.id),
      id: 'edit_project' %></li>

    <li><%= link_to t('task.link.new'), 
      new_project_link_path(@project.id),
      id: 'link_tasks' %></li>

    <li><%= link_to t('task.new'), 
      new_project_task_path(@project.id),
      id: 'new_task' %></li>

    <li><%= link_to t('contributor.new'), 
      new_project_contributor_path(@project.id),
      id: 'new_contributor' %></li>

  <% end %>
</ul>

<%= render partial: 'shared/login_logout' %>

<%= button_to t('project.trash'),
  project_trashes_path(@project),
  id: 'move_to_trash', class: 'btn btn-default',
  form_class: 'navbar-form navbar-right' %>

<%= render partial: 'shared/notifications_link',
           locals: { notifications_count: @notifications_count } %>

app/views/shared/_signing_account.html.erb
<ul class="nav navbar-nav">
	<li><%= link_to t('nav.home'), user_path(current_user) %></li>
	<li><%= link_to t('nav.my_projects'), user_projects_path(current_user) %></li>
	<li><%= link_to t('nav.shared_projects'), shared_projects_user_path(current_user) %></li>
	<li><%= link_to t('nav.trash'), user_trashes_path(current_user) %></li>
</ul>

<%= render partial: 'shared/login_logout' %>
<%= render partial: 'shared/notifications_link',
  locals: { notifications_count: @notifications_count } %>


app/views/shared/_task_controllers.html.erb
<ul class="nav navbar-nav">
  <li><%= link_to t('nav.home'), 
    user_path(current_user) %></li>

  <li><%= link_to @task.project.name, 
    project_path(@task.project) %></li>

  <li><%= link_to t('project.tasks'), 
    project_tasks_path(@task.project) %></li>

  <% if current_user == @task.owner %> 
    <li><%= link_to t('page.contributor.header'), 
      project_contributors_path(@task.project),
      id: 'project_contributors' %></li>

    <li><%= link_to t('task.edit'),
      edit_task_path(@task.id),
      id: 'edit_task' %></li>

    <li><%= link_to t('task.link.new'), 
      new_project_link_path(@task.project.id),
      id: 'link_tasks' %></li>

    <li><%= link_to t('task.unlink'),
      unlink_project_link_path(@task.project, @task),
      id: 'unlink_task' %></li>

    <li><%= link_to t('task.assignee.new'),
      new_task_assignee_path(@task),
      id: 'new_tasks_assignee' %></li>
  <% end %>
</ul>

<%= render partial: 'shared/login_logout' %>
<%= render partial: 'shared/notifications_link',
           locals: { notifications_count: @notifications_count } %>